<template>
  <div>
    <!--引用表格-->
    <BasicTable @register="registerTable">
      <!--插槽:table标题-->
      <template #tableTitle>
        <!-- v-auth="" -->
        <a-button type="primary" @click="handleAdd" v-auth="'reviewOrg:add'">新增</a-button>
        <!-- <a-button type="primary" preIcon="ant-design:export-outlined" @click="onExportXls"> 导出</a-button> -->
        <!-- <j-upload-button type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button> -->
      </template>
      <!--操作栏-->
      <!-- :dropDownActions="getDropDownAction(record)" -->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" />
      </template>
    </BasicTable>
  </div>
  <modal @register="registerModal" @sumbitTable="sumbitTable" />
</template>

<script lang="ts" name="system-reviewOrg" setup>
import { ref, computed, unref } from 'vue';
import { BasicTable, useTable, TableAction } from '/@/components/Table';
import { useModal } from '/@/components/Modal';
import { useListPage } from '/@/hooks/system/useListPage';
import { columns, searchFormSchema,} from './data';
import { list, save, edit, deleteData, deleteOne, batchDelete, getImportUrl, getExportUrl } from './api';
import modal from "./modal/modal.vue";
//注册model
const [registerModal, { openModal, closeModal }] = useModal();
//注册table数据
const { prefixCls, tableContext, onExportXls, onImportXls } = useListPage({
  tableProps: {
    title: '系统管理-机构评审',
    api: list,
    columns,
    canResize: false,
    //定义rowSelection的类型，默认是checkbox多选，可以设置成radio单选
    rowKey: 'id',
    clickToRowSelect: true,
    showIndexColumn: true,
    formConfig: {
      labelWidth: 120,
      schemas: searchFormSchema,
      autoSubmitOnEnter: true,
      showAdvancedButton: false,
    },
    actionColumn: {
      width: 120,
    },
  },
  exportConfig: {
    name: '后期管理-待受理',
    url: getExportUrl,
  },
  importConfig: {
    url: getImportUrl,
  },
});
const [registerTable, { reload }, { rowSelection, selectedRowKeys }] = tableContext;
async function sumbitTable(val) {
  if (val.id) {
    await edit(val)
  } else {
    await save(val)
  }
  closeModal()
  reload()
}
/**
 * 新增事件
 */
function handleAdd() {
  openModal(true, {
    isUpdate: false,
  });
}
/**
 * 编辑事件
 */
function handleEdit(record: Recordable) {
  openModal(true, record,);
}
/**
 * 详情
 */
function handleDetail(record: Recordable) {
  openModal(true, {
    record,
    isUpdate: true,
    showFooter: false,
  });
}
/**
 * 删除事件
 */
async function handleDelete(record) {
  await deleteData({ id: record.id });
  reload()
}
/**
 * 批量删除事件
 */
async function batchHandleDelete() {
  await batchDelete({ ids: selectedRowKeys.value }, reload);
}
/**
 * 成功回调
 */
function handleSuccess({ isUpdate, values }) {
  reload();
}
/**
 * 操作栏
 */
function getTableAction(record) {
  return [
    {
      label: '编辑',
      onClick: handleEdit.bind(null, record),
      auth: 'reviewOrg:edit',
    },
    {
      label: '删除',
      color: 'error',
      popConfirm: {
        title: '是否确认删除',
        confirm: handleDelete.bind(null, record),
      },
      auth: 'reviewOrg:delete',
    },
  ];
}
/**
 * 下拉操作栏
 */
function getDropDownAction(record) {
  return [
    {
      label: '详情',
      onClick: handleDetail.bind(null, record),
    },
    {
      label: '删除',
      popConfirm: {
        title: '是否确认删除',
        confirm: handleDelete.bind(null, record),
      },
    },
  ];
}
</script>
<style scoped></style>
